    PROGRAM f04asfe

!      F04ASF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : f04asf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, lda, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:), c(:), wk1(:), wk2(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F04ASF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       ALLOCATE (a(lda,n),b(n),c(n),wk1(n),wk2(n))
       READ (nin,*) (a(i,1:n),i=1,n), b(1:n)

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL f04asf(a,lda,b,n,c,wk1,wk2,ifail)

       WRITE (nout,*) ' Solution'
       WRITE (nout,99999) c(1:n)

99999  FORMAT (1X,F9.4)
    END PROGRAM f04asfe
